// pages/login/login.js
import WxValidate from '../../utils/wxValidate'
const app = getApp()
Page({
  /**
   * 页面的初始数据
   */
  data: {
    frameStyle: { useTop: true, name: '创建比赛', leftArrow: true, useBar: false },
    // 主体高度
    infoHeight: '',
    names: '',
    address: '',
    date: '2018-01-01',//默认起始时间  
    date2: '2018-01-24',//默认结束时间 
    singledate: '2018-09-01',
    time: '12:01',
    // 赛制信息
    // 默认值
    szValue: [],
    // 赛制选择信息
    valueList: [],
    // 原数据
    levelArray: [
      ['淘汰制', '循环制'],
      ['单败淘汰', '双败淘汰', '交叉淘汰'],
      ['单循环', '双循环', '四循环']
    ],
    // 赛制储存信息
    szList: [],
  },
  // 提交创建
  onSubmit: function (e) {
    var name = this.data.names;
    var match_time = this.data.date + ' - ' + this.data.date2;
    var single_time = this.data.singledate + ' ' + this.data.time;
    var address = this.data.address;
    var format = this.data.szList;
    const params = {
      "name": name,
      "match_time": match_time,
      "single_time": single_time,
      "address": address,
      "format": format,
    };
    if (!this.WxValidate.checkForm(params)) {
      const error = this.WxValidate.errorList[0];
      wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
      return false
    } else {
      wx.request({
        url: `${app.globalData.publicUrl}/courtAdmin/api/match`, //接口地址
        method: 'post',
        data: params,
        success(res) {
          if (res.data.errcode == 0) {
            wx.showToast({ title: `创建比赛成功`, icon: 'success', duration: 2000 }) //创建成功提示
            wx.navigateTo({ url: '/pages/administration/index' })// 跳转页面
          } else {
            wx.showToast({
              title: res.data.errmsg,
              icon: 'none',
              duration: 2000
            })
          }
        }
      })
    }
  },
  //input改变值
  onChangenames(e) {
    this.data.names = e.detail
  },
  //input改变值
  onChangeaddress(e) {
    this.data.address = e.detail
  },
  // 确定选择
  szChange: function (e) {
    const that = this;
    let value = e.detail.value;
    let list = that.data.valueList;
    let data = []
    for (let [index, val] of value.entries()) {
      if (list[index][val]) data.push(list[index][val])
      else data.push(list[index][0])
    }
    //存值
    let sz = [...that.data.szList, { type: data[0], name: data[1] }]
    that.setData({ szList: sz })
    that.setData({ szValue: data })
    that.search();
  },
  // 列值改变时
  columnChange: function (e) {
    const that = this;
    let array = that.data.levelArray;
    let list = that.data.valueList;
    if (e.detail.column == '0') list[1] = array[parseInt(e.detail.value) + 1];
    that.setData({ valueList: list });
  },
  //删除
  toDel: function (e) {
    const that = this;
    let list = that.data.szList;
    let value = e.currentTarget.dataset.index;
    let data = list.filter((i, index) => index != value)
    this.setData({ szList: data })
  },
  bindDateChange3: function (e) {
    this.setData({
      singledate: e.detail.value
    })
  },
  bindTimeChange: function (e) {
    this.setData({
      time: e.detail.value
    })
  },
  // 时间段选择  
  bindDateChange(e) {
    let that = this;
    that.setData({
      date: e.detail.value,
    })
  },
  bindDateChange2(e) {
    let that = this;
    that.setData({
      date2: e.detail.value,
    })
  },
  back: function () {
    wx.navigateBack({ url: '/pages/home/index' })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 监听用户是否登录
    this.watchLogin();
    //验证规则函数
    this.initValidate()
    // 计算高度
    this.searchHeight()
    const that = this;
    // 初始化数据
    that.search();
  },
  //验证是否输入
  initValidate() {
    const rules = { name: { required: true }, match_time: { required: true, }, single_time: { required: true }, address: { required: true, }, format: { required: true } }
    // 验证字段的提示信息，若不传则调用默认的信息
    const messages = { name: { required: '请输入比赛名称', }, match_time: { required: '请输入时间', }, single_time: { required: '请输入单场时间', }, address: { required: '请输入地点', }, format: { required: '请选择赛制', } };
    this.WxValidate = new WxValidate(rules, messages)
  },
  // 监听用户是否登录
  watchLogin: function () {
    wx.getStorage({
      key: 'token',
      success: res => {
      },
      fail: res => {
        return wx.redirectTo({ url: '/pages/login/index', })
      }
    })
  },
  //查找选择器的值
  search: function () {
    const that = this;
    let data = that.data.levelArray;
    that.setData({ valueList: [data[0], data[1]] })
  },
 // 计算高度
 searchHeight: function () {
  let frameStyle = this.data.frameStyle;
  let client = app.globalData.client;
  let infoHeight = client.windowHeight;
  // 是否去掉状态栏
  if (frameStyle.useTop) infoHeight = infoHeight - (client.statusBarHeight + client.getMenu.height + (client.getMenu.top - client.statusBarHeight) * 2);
  // 是否减去底部菜单
  if (frameStyle.useBar) infoHeight = infoHeight - 50;
  if (infoHeight) this.setData({ infoHeight: infoHeight })
},

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})